'''
Created on 28 sept. 2014

@author: coissac
'''

import orgasm.samples

__title__="Build the initial assembling graph"


def addOptions(parser):
    parser.add_argument('indexFilename', metavar='index', help='index root filename (produced by orgasmi)')
    parser.add_argument('outputFilename', metavar='output', help='output prefix', nargs='?', default=None)
    
    parser.add_argument('--minread', dest='minread', type=int, action='store', default=None, help='the minimum count of read to consider [default: <estimated>]')
    parser.add_argument('--coverage', dest='coverage', type=int, action='store', default=None, help='the expected sequencing coverage [default: <estimated>]')
    parser.add_argument('--minratio', dest='minratio', type=float, action='store', default=None, help='minimum ratio between occurrences of an extension and the occurrences of the most frequent extension to keep it. [default: <estimated>]')
    parser.add_argument('--mincov', dest='mincov', type=int, action='store', default=1, help='minimum occurrences of an extension to keep it. [default: %(default)d]')
    parser.add_argument('--minoverlap', dest='minoverlap', type=int, action='store', default=None, help='minimum length of the overlap between the sequence and reads to participate in the extension. [default: <estimated>]')
    parser.add_argument('--smallbranches', dest='smallbranches', type=int, action='store', default=None, help='maximum length of the branches to cut during the cleaning process [default: <estimated>]')
    parser.add_argument('--lowcomplexity', dest='lowcomplexity', action='store_true', default=False, help='Use also low complexity probes')
    parser.add_argument('--back', dest='back', type=int, action='store', default=None, help='the number of bases taken at the end of contigs to jump with pared-ends [default: <estimated>]')
    parser.add_argument('--snp', dest='snp', action='store_true', default=False, help='desactivate the SNP clearing mode')
    parser.add_argument('--log', dest='log', action='store_true', default=False, help='Create a logfile for the assembling')
    parser.add_argument('--seeds', dest ='seeds', metavar='seeds', default=None, type=str, help='protein seeds; either a file containing seeds proteic sequences or internal set of seeds among %s' % str(filter(lambda s: s.startswith('prot') or s.startswith('nuc'),dir(orgasm.samples))) )


def run():
    print "Coucou ici build graph"